/*
  Scrolling Lab:
  
  A red circle is drawn in the middle of the screen for reference.
  Scrolling is implemented and boundary lines are drawn so 
  that scrolling can be visualized. 
  
  There are two versions of this lab:
  1) Friendly Version. More helper code is provided in lab template.
  2) More Challenging Version. Less helper code is provided.
  For more detail, see the tutorial: https://youtu.be/y4smwQ794_M
   
  This is the more challenging version. 
  
  Complete the code as indicated by the comments.
  Do the following:
  1) In draw(), draw the top, bottom, left and right boundary lines. Do this
  in reference to view_x and view_y so that the lines scroll with the player.
  2) Implement scroll() method. See video above for reference. 
   
  See the comments below for more details. 
 
*/
final static float MOVE_SPEED = 4;
final static float SPRITE_SCALE = 50.0/128;
final static float SPRITE_SIZE = 50;


final static float RIGHT_MARGIN = 300;
final static float LEFT_MARGIN = 200;
final static float TOP_MARGIN = 100;
final static float BOTTOM_MARGIN = 100;


//declare global variables
Sprite player;


// unlike from our game, we'll make the boundary variables global
// and draw lines to see them to visualize how scrolling works. 
float left_bd, right_bd; // the x-coordinates of left and right boundaries
float top_bd, bottom_bd; // the y-coordinates of top and bottom boundaries

float view_x = 0;
float view_y = 0;



//initialize them in setup().
void setup(){
  size(800, 600);
  imageMode(CENTER);
  player = new Sprite("player.png", 0.8);
  player.center_x = width/2;
  player.center_y = height/2;
}

// modify and update them in draw().
void draw(){
  background(255);
  // scroll() needs to be the first method called!
  scroll();
  
  // red circle in the middle of screen for reference when scrolling.
  fill(255, 0, 0);
  ellipse(width/2, height/2, 100, 100); // diameter = 50
  
  // draw left, right, top, bottom boundaries to see how scrolling works
  // use line(x1, y1, x2, y2) to draw line connection two points: (x1, y1) and (x2, y2)
  
  stroke(255, 0, 0); // red stroke for lines
  // left vertical boundary
  
  // draw the other boundaries
  // right boundary

  // top boundary
  
  // bottom boundary
  
  
  player.update();
  player.display();

} 
void scroll(){
  // compute x-coordinate of right boundary
  // if player's right passed this boundary, update view_x

  
  
  // compute x-coordinate of left boundary
  // if player's left passed this boundary, update view_x


  
  // compute y-coordinate of bottom boundary
  // if player's bottom passed this boundary, update view_y


  
  // compute y-coordinate of top boundary
  // if player's top passed this boundary, update view_y

  
  // translate the game world coordinate in the opposite direction
  // of (view_x, view_y).


}

// called whenever a key is pressed.
void keyPressed(){
  if(keyCode == RIGHT){
    player.change_x = MOVE_SPEED;
  }
  else if(keyCode == LEFT){
    player.change_x = -MOVE_SPEED;
  }
  else if(keyCode == UP){
    player.change_y = -MOVE_SPEED;
  }
  else if(keyCode == DOWN){
    player.change_y = MOVE_SPEED;
  }

}

// called whenever a key is released.
void keyReleased(){
  if(keyCode == RIGHT){
    player.change_x = 0;
  }
  else if(keyCode == LEFT){
    player.change_x = 0;
  }
  else if(keyCode == UP){
    player.change_y = 0;
  }
  else if(keyCode == DOWN){
    player.change_y = 0;
  }

}
